# Gosse Adema

import RPi.GPIO as GPIO
import time
GPIO.setmode(GPIO.BCM)

def report_keyboard(c,k):
    with open('/dev/hidg0', 'rb+') as fk:
        fk.write((c).to_bytes(1, byteorder='big')+    \
                 (0).to_bytes(1, byteorder='big')+    \
                 (k[0]).to_bytes(1, byteorder='big')+ \
                 (k[1]).to_bytes(1, byteorder='big')+ \
                 (k[2]).to_bytes(1, byteorder='big')+ \
                 (k[3]).to_bytes(1, byteorder='big')+ \
                 (k[4]).to_bytes(1, byteorder='big')+ \
                 (k[5]).to_bytes(1, byteorder='big'))

ValMouseButton1 = 1 # left (a)
ValMouseButton2 = 2 # right (b)
ValMouseButton3 = 4 # middle (c)
ValMouseMove    = 3 # movement
MouseSpeed      = 1 # mousemod

def report_mouse(b,x,y,w):
    if x<0:
        x=x+256
    if y<0:
        y=y+256
    if w<0:
        w=w+256
    with open('/dev/hidg1', 'rb+') as fm:
        fm.write((b).to_bytes(1, byteorder='big')+ \
                 (x).to_bytes(1, byteorder='big')+ \
                 (y).to_bytes(1, byteorder='big')+ \
                 (w).to_bytes(1, byteorder='big'))

MaxtrixRows = [8, 25, 7, 24, 23]
MaxtrixCols = [18, 4, 17, 27, 22, 10, 9, 6, 13, 19, 26, 21, 20, 16, 12]

#          `~     1     2     3     4     5     6     7     8     9     0    -_    =+   DEL   PUP
#         LM1   TAB     1     w     e     r     t     y     u     i     o     p    [{    ]}    \|
#         LM2   MSE     a     s     d     f     g     h     j     k     l    :;    "'  ENTR   RM2
#         LM3  SHFT     x     x     c     v     b     n     m    ,<    .>    /?  SHFT    UP   PDN
#         LM4  CTRL   WIN   ALT    FN   SPC         SPC    FN   ALT   WIN  CTRL   LFT   DWN   RGT

Hid = [[   53,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   45,   46,   42,   75]
      ,[  222,   43,   20,   26,    8,   21,   23,   28,   24,   12,   18,   19,   47,   48,   49]
      ,[  223,    2,    4,   22,    7,    9,   10,   11,   13,   14,   15,   51,   52,   40,    0]
      ,[  224,   -2,   29,   27,    6,   25,    5,   17,   16,   54,   55,   56,  -32,   82,   78]
      ,[  225,   -1,   -8,   -4,    1,   44,    0,   44,    1,  -64, -128,  -16,   80,   81,   79]]

HFn = [[   41,   58,   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,   69,   42,   75]
      ,[  222,   43,   41,    0,    0,    0,    0,   75,   74,   82,   77,   76,   70,   71,   72]
      ,[  223,    2,   57,    0,    0,    0,    0,   78,   80,   81,   79,   73,    0,   40,    0]
      ,[  224,   -2,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  -32,   82,   78]
      ,[  225,   -1,   -8,   -4,    1,   44,    0,   44,    1,  -64, -128,  -16,   80,   81,   79]]

HMs = [[    0,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,    0,    0,    0,   75]
      ,[    0,    0,    0,    4,    5,    6,    0,   75,    4,   82,    6,    0,    0,    0,    0]
      ,[    0,    2,    0,    0,    0,    0,    0,   78,   80,   81,   79,    0,    0,    0,    6]
      ,[    0,   -2,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,  -32,   82,   78]
      ,[    0,   -1,   -8,   -4,    1,    0,    0,    0,    0,  -64, -128,    4,   80,   81,   79]]

KeyMouse   = [2,1] # 3 down 3 to the right, value = 2. usage of this value is replaced by the matrix position.
KeyFnLeft  = [4,4] # 5 down 5 to the right, value = 1.
KeyFnRight = [4,8] # 5 down 9 to the right, value = 1.
KeyMod     = [4,5] # 5 down 6 to the right, value = 0.

OldCtrl = 0
OldKeys = [0,0,0,0,0,0]

GPIO.setwarnings(False)

for RowValue in MaxtrixRows:
   GPIO.setup(RowValue, GPIO.IN, pull_up_down = GPIO.PUD_DOWN)

for ColValue in MaxtrixCols:
   GPIO.setup(ColValue, GPIO.OUT)
   GPIO.output(ColValue, 0)

while True:

   time.sleep (0.05)

   #
   # ScanProcessor
   #

   KeyStack = []

   for ColNo, ColValue in enumerate (MaxtrixCols):
      GPIO.output(ColValue, 1)
      for RowNo, RowValue in enumerate (MaxtrixRows):
         if(GPIO.input(RowValue) == 1):
            KeyStack.append([RowNo, ColNo])
      GPIO.output(ColValue, 0)

   #
   # KeyProcessor
   #

   HidList = HFnList = []
   HidCtrl = HFnCtrl = FnPress = 0
   Mouse = MouseMoveX = MouseMoveY = MouseMoveW = MousePress = 0

   if KeyStack.count (KeyFnLeft) or KeyStack.count (KeyFnRight):
      print("Fn")
      for r,c in KeyStack:

         Key = HFn [r][c]

         if Key < 0:
            HidCtrl = HidCtrl - Key
         elif Key == 222:
             print ('Macro 1')
         elif Key == 223:
             print ('Macro 2')
         elif Key == 224:
             print ('Macro 3')
         elif Key == 225:
             print ('Macro 4')
         elif Key >= 4 and Key <222:
            HidList.append (Key)

   elif KeyStack.count (KeyMouse):

      for r,c in KeyStack:

         Key = HMs [r][c]

         if KeyStack.count (KeyMod):
            MouseSpeed = 2 # Double the mouse speed with MOD key
         else:
            MouseSpeed = 1

         if Key >= 30 and Key <= 39: 
            ValMouseMove = ((Key - 30) * 2) + 1 # Set mouse speed with 1, 2, 3

         if Key == 79	:
            MouseMoveX = MouseMoveX + (ValMouseMove * MouseSpeed)

         if Key == 80	:
            MouseMoveX = MouseMoveX - (ValMouseMove * MouseSpeed)

         if Key == 81:
            MouseMoveY = MouseMoveY + (ValMouseMove * MouseSpeed)

         if Key == 82:
            MouseMoveY = MouseMoveY - (ValMouseMove * MouseSpeed)

         if Key == 75:
            MouseMoveW = MouseMoveW + (ValMouseMove * MouseSpeed)

         if Key == 78:
            MouseMoveW = MouseMoveW - (ValMouseMove * MouseSpeed)

         if Key == 4: # (a)
            MousePress = MousePress + ValMouseButton1

         if Key == 5: # (b)
            MousePress = MousePress + ValMouseButton2

         if Key == 6: # (c)
            MousePress = MousePress + ValMouseButton3

         if MousePress or MouseMoveX or MouseMoveY or MouseMoveW:
            Mouse = 1 # mouse in use

#  elif KeyStack.count (KeyMod):
#     print ('mod')

   else: # no fn/mod/mouse key

      for r,c in KeyStack:

         Key = Hid [r][c]

         if Key < 0:
            HidCtrl = HidCtrl - Key
         elif Key == 222:
             print ('Macro 1')
         elif Key == 223:
             print ('Macro 2')
         elif Key == 224:
             print ('Macro 3')
         elif Key == 225:
             print ('Macro 4')
         elif Key >= 4 and Key <222:
            HidList.append (Key)

   #
   # OutputProcessor
   #

   UseCtrl = HidCtrl
   UseList = list(dict.fromkeys(HidList)) # no duplicates

   # only first 6 keys, no error report
   for i in range (len(UseList), 6):
      UseList.append (0)

   if ((OldKeys > UseList) - (OldKeys < UseList)) != 0 or (OldCtrl != UseCtrl):
      report_keyboard(UseCtrl,UseList)
      OldCtrl = UseCtrl # store value, only send changes
      OldKeys = UseList

   if (Mouse == 1):
      report_mouse(MousePress,MouseMoveX,MouseMoveY,MouseMoveW)
